--- /dev/null	2011-08-19 15:42:51.000000000 +0100
+++ libwnck-3.0.2/libwnck/trusted-tooltips.c	2011-08-19 15:41:16.282867297 +0100
@@ -0,0 +1,921 @@
+/* GTK - The GIMP Toolkit
+ * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+ */
+
+/*
+ * Modified by the GTK+ Team and others 1997-2000.  See the AUTHORS
+ * file for a list of people on the GTK+ Team.  See the ChangeLog
+ * files for a list of changes.  These files are distributed with
+ * GTK+ at ftp://ftp.gtk.org/pub/gtk/. 
+ *
+ * Modified for trusted JDS by Erwann Chenede - <erwann.chenede@sun.com> 2005
+ * Copyright (C) Sun Microsystems 2005 
+ */
+
+#include <config.h>
+#include <stdlib.h>
+#include <string.h>
+#include <stdio.h>
+
+#ifdef HAVE_XTSOL
+#include "trusted-tooltips.h"
+#include "workspace.h"
+#include <wnck-tsol.h>
+#include <gtk/gtk.h>
+
+
+#define DEFAULT_DELAY 500           /* Default delay in ms */
+#define STICKY_DELAY 0              /* Delay before popping up next tip
+                                     * if we're sticky
+                                     */
+#define STICKY_REVERT_DELAY 1000    /* Delay before sticky tooltips revert
+				     * to normal
+                                     */
+
+static void trusted_tooltips_class_init        (TrustedTooltipsClass *klass);
+static void trusted_tooltips_init              (TrustedTooltips      *tooltips);
+static void trusted_tooltips_destroy           (GObject        *object);
+
+static void trusted_tooltips_event_handler     (GtkWidget   *widget,
+                                            GdkEvent    *event);
+static void trusted_tooltips_widget_unmap      (GtkWidget   *widget,
+                                            gpointer     data);
+static void trusted_tooltips_widget_remove     (GtkWidget   *widget,
+                                            gpointer     data);
+static void trusted_tooltips_set_active_widget (TrustedTooltips *tooltips,
+                                            GtkWidget   *widget);
+static gint trusted_tooltips_timeout           (gpointer     data);
+
+static gint trusted_tooltips_paint_window      (TrustedTooltips *tooltips,
+                                                cairo_t         *cr);
+static void trusted_tooltips_draw_tips         (TrustedTooltips *tooltips);
+static void trusted_tooltips_unset_tip_window  (TrustedTooltips *tooltips);
+
+static gboolean get_keyboard_mode          (GtkWidget   *widget);
+
+static GObjectClass *parent_class;
+static const gchar  tooltips_data_key[] = "_TrustedTooltipsData";
+static const gchar  tooltips_info_key[] = "_TrustedTooltipsInfo";
+
+GType
+trusted_tooltips_get_type (void)
+{
+  static GType tooltips_type = 0;
+
+  if (!tooltips_type)
+    {
+      static const GTypeInfo tooltips_info =
+      {
+	sizeof (TrustedTooltipsClass),
+	NULL,		/* base_init */
+	NULL,		/* base_finalize */
+	(GClassInitFunc) trusted_tooltips_class_init,
+	NULL,		/* class_finalize */
+	NULL,		/* class_data */
+	sizeof (TrustedTooltips),
+	0,		/* n_preallocs */
+	(GInstanceInitFunc) trusted_tooltips_init,
+      };
+
+      tooltips_type = g_type_register_static (G_TYPE_OBJECT, "TrustedTooltips",
+					      &tooltips_info, 0);
+    }
+
+  return tooltips_type;
+}
+
+static void
+trusted_tooltips_class_init (TrustedTooltipsClass *class)
+{
+  GObjectClass *object_class;
+
+  object_class = (GObjectClass*) class;
+
+  parent_class = g_type_class_peek_parent (class);
+
+  /*object_class->destroy = trusted_tooltips_destroy;*/
+}
+
+static void
+trusted_tooltips_init (TrustedTooltips *tooltips)
+{
+  tooltips->tip_window = NULL;
+  tooltips->active_tips_data = NULL;
+  tooltips->tips_data_list = NULL;
+  
+  tooltips->delay = DEFAULT_DELAY;
+  tooltips->enabled = TRUE;
+  tooltips->timer_tag = 0;
+  tooltips->use_sticky_delay = FALSE;
+  tooltips->last_popdown.tv_sec = -1;
+  tooltips->last_popdown.tv_usec = -1;
+  tooltips->pager = NULL;
+}
+
+TrustedTooltips *
+trusted_tooltips_new (void)
+{
+  return g_object_new (TRUSTED_TOOLTIPS_TYPE, NULL);
+}
+
+static void
+trusted_tooltips_destroy_data (TrustedTooltipsData *tooltipsdata)
+{
+  g_free (tooltipsdata->tip_text);
+  g_free (tooltipsdata->trusted_label);
+  g_free (tooltipsdata->tip_private);
+
+  g_signal_handlers_disconnect_by_func (tooltipsdata->widget,
+				        (gpointer)trusted_tooltips_event_handler,
+					tooltipsdata);
+  g_signal_handlers_disconnect_by_func (tooltipsdata->widget,
+					(gpointer)trusted_tooltips_widget_unmap,
+					tooltipsdata);
+  g_signal_handlers_disconnect_by_func (tooltipsdata->widget,
+					(gpointer)trusted_tooltips_widget_remove,
+					tooltipsdata);
+
+  g_object_set_data (G_OBJECT (tooltipsdata->widget), tooltips_data_key, NULL);
+  g_object_unref (tooltipsdata->widget);
+  g_free (tooltipsdata);
+}
+
+static void
+tip_window_display_closed (GdkDisplay  *display,
+			   gboolean     was_error,
+			   TrustedTooltips *tooltips)
+{
+  trusted_tooltips_unset_tip_window (tooltips);
+}
+
+static void
+disconnect_tip_window_display_closed (TrustedTooltips *tooltips)
+{
+  g_signal_handlers_disconnect_by_func (gtk_widget_get_display (tooltips->tip_window),
+					(gpointer) tip_window_display_closed,
+					tooltips);
+}
+
+static void
+trusted_tooltips_unset_tip_window (TrustedTooltips *tooltips)
+{
+  if (tooltips->tip_window)
+    {
+      disconnect_tip_window_display_closed (tooltips);
+      
+      gtk_widget_destroy (tooltips->tip_window);
+      tooltips->tip_window = NULL;
+    }
+}
+
+static void
+trusted_tooltips_destroy (GObject *object)
+{
+  TrustedTooltips *tooltips = TRUSTED_TOOLTIPS (object);
+  GList *current;
+  TrustedTooltipsData *tooltipsdata;
+
+  g_return_if_fail (tooltips != NULL);
+
+  if (tooltips->timer_tag)
+    {
+      g_source_remove (tooltips->timer_tag);
+      tooltips->timer_tag = 0;
+    }
+
+  if (tooltips->tips_data_list != NULL)
+    {
+      current = g_list_first (tooltips->tips_data_list);
+      while (current != NULL)
+	{
+	  tooltipsdata = (TrustedTooltipsData*) current->data;
+	  current = current->next;
+	  trusted_tooltips_widget_remove (tooltipsdata->widget, tooltipsdata);
+	}
+    }
+
+  trusted_tooltips_unset_tip_window (tooltips);
+
+  /*G_OBJECT_CLASS (parent_class)->destroy (object);*/
+}
+
+static void
+trusted_tooltips_update_screen (TrustedTooltips *tooltips,
+			    gboolean     new_window)
+{
+  gboolean screen_changed = FALSE;
+  
+  if (tooltips->active_tips_data &&
+      tooltips->active_tips_data->widget)
+    {
+      GdkScreen *screen = gtk_widget_get_screen (tooltips->active_tips_data->widget);
+
+      screen_changed = (screen != gtk_widget_get_screen (tooltips->tip_window));
+
+      if (screen_changed)
+	{
+	  if (!new_window)
+	    disconnect_tip_window_display_closed (tooltips);
+      
+	  gtk_window_set_screen (GTK_WINDOW (tooltips->tip_window), screen);
+	}
+    }
+
+  if (screen_changed || new_window)
+    g_signal_connect (gtk_widget_get_display (tooltips->tip_window), "closed",
+		      G_CALLBACK (tip_window_display_closed), tooltips);
+
+}
+
+void
+trusted_tooltips_force_window (TrustedTooltips *tooltips)
+{
+  g_return_if_fail (IS_TRUSTED_TOOLTIPS (tooltips));
+
+  if (!tooltips->tip_window)
+    {
+      GtkWidget * vbox;
+
+      tooltips->tip_window = gtk_window_new (GTK_WINDOW_POPUP);
+      trusted_tooltips_update_screen (tooltips, TRUE);
+      gtk_widget_set_app_paintable (tooltips->tip_window, TRUE);
+      gtk_window_set_resizable (GTK_WINDOW (tooltips->tip_window), FALSE);
+      gtk_widget_set_name (tooltips->tip_window, "gtk-tooltips");
+      gtk_container_set_border_width (GTK_CONTAINER (tooltips->tip_window), 2);
+
+      g_signal_connect_swapped (tooltips->tip_window,
+				"draw",
+				G_CALLBACK (trusted_tooltips_paint_window), 
+				tooltips);
+
+      tooltips->tip_label = gtk_label_new (NULL);
+      gtk_label_set_line_wrap (GTK_LABEL (tooltips->tip_label), FALSE);
+      gtk_misc_set_alignment (GTK_MISC (tooltips->tip_label), 0.5, 0.5);
+      gtk_widget_show (tooltips->tip_label);
+
+      tooltips->tip_trusted_label = gtk_label_new (NULL);
+      gtk_label_set_line_wrap (GTK_LABEL (tooltips->tip_trusted_label), FALSE);
+      gtk_misc_set_alignment (GTK_MISC (tooltips->tip_trusted_label), 0.5, 0.5);
+      gtk_widget_show (tooltips->tip_trusted_label);
+
+      vbox = gtk_vbox_new (FALSE, 1);
+      tooltips->event = gtk_event_box_new ();
+
+      gtk_container_add (GTK_CONTAINER (tooltips->event), tooltips->tip_trusted_label);
+      
+      gtk_container_add (GTK_CONTAINER (vbox), tooltips->event);
+
+      gtk_container_add (GTK_CONTAINER (vbox), tooltips->tip_label);
+      gtk_container_add (GTK_CONTAINER (tooltips->tip_window), vbox);
+
+      gtk_widget_show (vbox);
+      gtk_widget_show (tooltips->event);
+
+      g_signal_connect (tooltips->tip_window,
+			"destroy",
+			G_CALLBACK (gtk_widget_destroyed),
+			&tooltips->tip_window);
+    }
+}
+
+void
+trusted_tooltips_enable (TrustedTooltips *tooltips)
+{
+  g_return_if_fail (tooltips != NULL);
+
+  tooltips->enabled = TRUE;
+}
+
+void
+trusted_tooltips_disable (TrustedTooltips *tooltips)
+{
+  g_return_if_fail (tooltips != NULL);
+
+  trusted_tooltips_set_active_widget (tooltips, NULL);
+
+  tooltips->enabled = FALSE;
+}
+
+void
+trusted_tooltips_set_delay (TrustedTooltips *tooltips,
+                        guint         delay)
+{
+  g_return_if_fail (tooltips != NULL);
+
+  tooltips->delay = delay;
+}
+
+TrustedTooltipsData*
+trusted_tooltips_data_get (GtkWidget       *widget)
+{
+  g_return_val_if_fail (widget != NULL, NULL);
+
+  return g_object_get_data (G_OBJECT (widget), tooltips_data_key);
+}
+
+void
+trusted_tooltips_set_tip (TrustedTooltips *tooltips,
+		      GtkWidget   *widget,
+		      const gchar *tip_text,
+		      const gchar *trusted_label,
+		      GdkColor	  *trusted_color,
+		      const gchar *tip_private)
+{
+  TrustedTooltipsData *tooltipsdata;
+
+  g_return_if_fail (IS_TRUSTED_TOOLTIPS (tooltips));
+  g_return_if_fail (widget != NULL);
+
+  tooltipsdata = trusted_tooltips_data_get (widget);
+
+  if (!tip_text)
+    {
+      if (tooltipsdata)
+	trusted_tooltips_widget_remove (tooltipsdata->widget, tooltipsdata);
+      return;
+    }
+  
+  if (tooltips->active_tips_data 
+      && tooltips->active_tips_data->widget == widget
+      && gtk_widget_is_drawable (tooltips->active_tips_data->widget))
+    {
+      g_free (tooltipsdata->tip_text);
+      g_free (tooltipsdata->tip_private);
+
+      tooltipsdata->tip_text = g_strdup (tip_text);
+      tooltipsdata->tip_private = g_strdup (tip_private);
+      
+      trusted_tooltips_draw_tips (tooltips);
+    }
+  else 
+    {
+      g_object_ref (widget);
+      
+      if (tooltipsdata)
+        trusted_tooltips_widget_remove (tooltipsdata->widget, tooltipsdata);
+      
+      tooltipsdata = g_new0 (TrustedTooltipsData, 1);
+      
+      tooltipsdata->tooltips = tooltips;
+      tooltipsdata->widget = widget;
+
+      tooltipsdata->tip_text = g_strdup (tip_text);
+      tooltipsdata->trusted_label = g_strdup (trusted_label);
+      tooltipsdata->tip_private = g_strdup (tip_private);
+      if (trusted_color)
+	tooltipsdata->trusted_color = trusted_color;
+
+      tooltips->tips_data_list = g_list_append (tooltips->tips_data_list,
+                                                tooltipsdata);
+      g_signal_connect_after (widget, "event-after",
+                              G_CALLBACK (trusted_tooltips_event_handler),
+			      tooltipsdata);
+
+      g_object_set_data (G_OBJECT (widget), tooltips_data_key,
+                         tooltipsdata);
+
+      g_signal_connect (widget, "unmap",
+			G_CALLBACK (trusted_tooltips_widget_unmap),
+			tooltipsdata);
+
+      g_signal_connect (widget, "unrealize",
+			G_CALLBACK (trusted_tooltips_widget_unmap),
+			tooltipsdata);
+
+      g_signal_connect (widget, "destroy",
+                        G_CALLBACK (trusted_tooltips_widget_remove),
+			tooltipsdata);
+    }
+}
+
+static gint
+trusted_tooltips_paint_window (TrustedTooltips *tooltips,
+                               cairo_t         *cr)
+{
+  GtkRequisition req;
+  GtkStyleContext *context;
+
+  context = gtk_widget_get_style_context (tooltips->tip_window);
+
+  gtk_widget_size_request (tooltips->tip_window, &req);
+  gtk_render_background (context, cr, 0, 0, req.width, req.height);
+  gtk_render_frame (context, cr, 0, 0, req.width, req.height);
+
+  return FALSE;
+}
+
+static void
+trusted_tooltips_draw_tips (TrustedTooltips *tooltips)
+{
+  GtkRequisition requisition;
+  GtkAllocation allocation;
+  GtkWidget *widget;
+  GtkStyle *style;
+  gint x, y, w, h;
+  TrustedTooltipsData *data;
+  gboolean keyboard_mode;
+  GdkScreen *screen;
+  GdkScreen *pointer_screen;
+  gint monitor_num, px, py;
+  GdkRectangle monitor;
+
+  if (!tooltips->tip_window)
+    trusted_tooltips_force_window (tooltips);
+  else if (gtk_widget_get_visible (tooltips->tip_window))
+    g_get_current_time (&tooltips->last_popdown);
+
+  gtk_widget_ensure_style (tooltips->tip_window);
+  style = gtk_widget_get_style(tooltips->tip_window);
+  
+  widget = tooltips->active_tips_data->widget;
+  g_object_set_data (G_OBJECT (tooltips->tip_window), tooltips_info_key,
+                     tooltips);
+
+  keyboard_mode = get_keyboard_mode (widget);
+
+  trusted_tooltips_update_screen (tooltips, FALSE);
+  
+  screen = gtk_widget_get_screen (widget);
+
+  data = tooltips->active_tips_data;
+
+  if (tooltips->pager) /* pager special case */
+    {
+      char *colorname;
+      int error;
+      GdkColor label_color;
+      m_label_t *mlabel = NULL;
+      WnckWorkspace *tip_ws = g_object_get_data (G_OBJECT (tooltips->pager), 
+						 "tip_ws");
+						 
+      const char *label = wnck_workspace_get_label (tip_ws);
+      
+      gtk_label_set_text (GTK_LABEL (tooltips->tip_label), 
+			  wnck_workspace_get_name (tip_ws)); 
+      
+      if (_wnck_use_trusted_extensions ())
+	{
+	  if (label != NULL && 
+	      (error = libtsol_str_to_label (label, &mlabel, MAC_LABEL, 
+				     L_NO_CORRECTION, &error)) == 0) 
+	    {
+	      GdkPixbuf *pb;
+	      guint32 rgba;
+	      char *readable_label;
+	      
+	      error = libtsol_label_to_str (mlabel, &colorname, M_COLOR, DEF_NAMES);
+	      
+#define DEFAULT_COLOR	"white"	  
+	      if (colorname == NULL)
+		colorname = g_strdup(DEFAULT_COLOR);
+	      
+	      gdk_color_parse ((const char*)colorname, &label_color);
+	      
+	      g_free (colorname);
+	      
+	      
+	      readable_label = wnck_workspace_get_human_readable_label (tip_ws);
+	      
+	      gtk_label_set_text (GTK_LABEL (tooltips->tip_trusted_label), readable_label);
+	      
+	      g_free (readable_label);
+	      
+	      gtk_widget_modify_bg (tooltips->event, GTK_STATE_NORMAL, &label_color);
+	      
+	      gtk_widget_show (tooltips->event);
+	    }
+	  else /* failed call to libtsol_label_to_str */
+	    gtk_widget_hide (tooltips->event);
+	}
+      else /* not using trusted_extensions */
+	gtk_widget_hide (tooltips->event);
+    }
+  else
+    {
+      gtk_label_set_text (GTK_LABEL (tooltips->tip_label), data->tip_text);
+      gtk_label_set_text (GTK_LABEL (tooltips->tip_trusted_label), data->trusted_label);
+      gtk_widget_modify_bg (tooltips->event, GTK_STATE_NORMAL, data->trusted_color);
+      if (data->trusted_color == NULL)
+	gtk_widget_hide (tooltips->event);
+      else
+	gtk_widget_show (tooltips->event);
+    }
+    
+ 
+  gtk_widget_size_request (tooltips->tip_window, &requisition);
+  w = requisition.width;
+  h = requisition.height;
+
+  gdk_window_get_origin (gtk_widget_get_window(widget), &x, &y);
+  gtk_widget_get_allocation(widget, &allocation);
+  if (!gtk_widget_get_has_window (widget))
+    {
+      x += allocation.x;
+      y += allocation.y;
+    }
+
+  x += allocation.width / 2;
+    
+  if (!keyboard_mode)
+    gdk_window_get_pointer (gdk_screen_get_root_window (screen),
+			    &x, NULL, NULL);
+
+  x -= (w / 2 + 4);
+
+  gdk_display_get_pointer (gdk_screen_get_display (screen),
+			   &pointer_screen, &px, &py, NULL);
+  if (pointer_screen != screen) 
+    {
+      px = x;
+      py = y;
+    }
+  monitor_num = gdk_screen_get_monitor_at_point (screen, px, py);
+  gdk_screen_get_monitor_geometry (screen, monitor_num, &monitor);
+
+  if ((x + w) > monitor.x + monitor.width)
+    x -= (x + w) - (monitor.x + monitor.width);
+  else if (x < monitor.x)
+    x = monitor.x;
+
+  if ((y + h + allocation.height + 4) > monitor.y + monitor.height)
+    y = y - h - 4;
+  else
+    y = y + allocation.height + 4;
+
+  gtk_window_move (GTK_WINDOW (tooltips->tip_window), x, y);
+  gtk_widget_show (tooltips->tip_window);
+}
+
+static gint
+trusted_tooltips_timeout (gpointer data)
+{
+  TrustedTooltips *tooltips = (TrustedTooltips *) data;
+
+  GDK_THREADS_ENTER ();
+  
+  if (tooltips->active_tips_data != NULL &&
+      gtk_widget_is_drawable (tooltips->active_tips_data->widget))
+    trusted_tooltips_draw_tips (tooltips);
+
+  GDK_THREADS_LEAVE ();
+
+  return FALSE;
+}
+
+static void
+trusted_tooltips_set_active_widget (TrustedTooltips *tooltips,
+                                GtkWidget   *widget)
+{
+  if (tooltips->tip_window)
+    {
+      if (gtk_widget_get_visible (tooltips->tip_window))
+	g_get_current_time (&tooltips->last_popdown);
+      gtk_widget_hide (tooltips->tip_window);
+    }
+  if (tooltips->timer_tag)
+    {
+      g_source_remove (tooltips->timer_tag);
+      tooltips->timer_tag = 0;
+    }
+  
+  tooltips->active_tips_data = NULL;
+  
+  if (widget)
+    {
+      GList *list;
+      
+      for (list = tooltips->tips_data_list; list; list = list->next)
+	{
+	  TrustedTooltipsData *tooltipsdata;
+	  
+	  tooltipsdata = list->data;
+	  
+	  if (tooltipsdata->widget == widget &&
+	      gtk_widget_is_drawable (widget))
+	    {
+	      tooltips->active_tips_data = tooltipsdata;
+	      break;
+	    }
+	}
+    }
+  else
+    {
+      tooltips->use_sticky_delay = FALSE;
+    }
+}
+
+static void
+trusted_tooltips_show_tip (GtkWidget *widget)
+{
+  TrustedTooltipsData *tooltipsdata;
+
+  tooltipsdata = trusted_tooltips_data_get (widget);
+
+  if (tooltipsdata &&
+      (!tooltipsdata->tooltips->active_tips_data ||
+       tooltipsdata->tooltips->active_tips_data->widget != widget))
+    {
+      trusted_tooltips_set_active_widget (tooltipsdata->tooltips, widget);
+      trusted_tooltips_draw_tips (tooltipsdata->tooltips);
+    }
+}
+
+static void
+trusted_tooltips_hide_tip (GtkWidget *widget)
+{
+  TrustedTooltipsData *tooltipsdata;
+
+  tooltipsdata = trusted_tooltips_data_get (widget);
+
+  if (tooltipsdata &&
+      (tooltipsdata->tooltips->active_tips_data &&
+       tooltipsdata->tooltips->active_tips_data->widget == widget))
+    trusted_tooltips_set_active_widget (tooltipsdata->tooltips, NULL);
+}
+
+static gboolean
+trusted_tooltips_recently_shown (TrustedTooltips *tooltips)
+{
+  GTimeVal now;
+  glong msec;
+  
+  g_get_current_time (&now);
+  msec = (now.tv_sec  - tooltips->last_popdown.tv_sec) * 1000 +
+	  (now.tv_usec - tooltips->last_popdown.tv_usec) / 1000;
+  return (msec < STICKY_REVERT_DELAY);
+}
+
+static gboolean
+get_keyboard_mode (GtkWidget *widget)
+{
+  GtkWidget *toplevel = gtk_widget_get_toplevel (widget);
+  if (GTK_IS_WINDOW (toplevel))
+    return GPOINTER_TO_UINT (g_object_get_data (G_OBJECT (toplevel), "gtk-tooltips-keyboard-mode"));
+  else
+    return FALSE;
+}
+
+static void
+start_keyboard_mode (GtkWidget *widget)
+{
+  GtkWidget *toplevel = gtk_widget_get_toplevel (widget);
+  if (GTK_IS_WINDOW (toplevel))
+    {
+      GtkWidget *focus = gtk_window_get_focus(GTK_WINDOW (toplevel));
+
+      g_object_set_data (G_OBJECT (toplevel), "gtk-tooltips-keyboard-mode", GUINT_TO_POINTER (TRUE));
+
+      if (focus)
+	trusted_tooltips_show_tip (focus);
+    }
+}
+
+static void
+stop_keyboard_mode (GtkWidget *widget)
+{
+  GtkWidget *toplevel = gtk_widget_get_toplevel (widget);
+  if (GTK_IS_WINDOW (toplevel))
+    {
+      GtkWidget *focus = gtk_window_get_focus(GTK_WINDOW (toplevel));
+      if (focus)
+	trusted_tooltips_hide_tip (focus);
+      
+      g_object_set_data (G_OBJECT (toplevel), "gtk-tooltips-keyboard-mode", GUINT_TO_POINTER (FALSE));
+    }
+}
+
+static void
+trusted_tooltips_start_delay (TrustedTooltips *tooltips,
+			  GtkWidget   *widget)
+{
+  TrustedTooltipsData *old_tips_data;
+  
+  old_tips_data = tooltips->active_tips_data;
+  if (tooltips->enabled &&
+      (!old_tips_data || old_tips_data->widget != widget))
+    {
+      guint delay;
+      
+      trusted_tooltips_set_active_widget (tooltips, widget);
+      
+      if (tooltips->use_sticky_delay &&
+	  trusted_tooltips_recently_shown (tooltips))
+	delay = STICKY_DELAY;
+      else
+	delay = tooltips->delay;
+      tooltips->timer_tag = g_timeout_add (delay,
+					   trusted_tooltips_timeout,
+					   (gpointer) tooltips);
+    }
+}
+
+static void
+trusted_tooltips_event_handler (GtkWidget *widget,
+                            GdkEvent  *event)
+{
+  TrustedTooltips *tooltips;
+  TrustedTooltipsData *old_tips_data;
+  GtkWidget *event_widget;
+  gboolean keyboard_mode = get_keyboard_mode (widget);
+
+
+  if ((event->type == GDK_LEAVE_NOTIFY || event->type == GDK_ENTER_NOTIFY) &&
+      event->crossing.detail == GDK_NOTIFY_INFERIOR)
+    return;
+  
+  old_tips_data = trusted_tooltips_data_get (widget);
+  tooltips = old_tips_data->tooltips;
+
+  if (keyboard_mode)
+    {
+      switch (event->type)
+	{
+	case GDK_FOCUS_CHANGE:
+	  if (event->focus_change.in)
+	    trusted_tooltips_show_tip (widget);
+	  else
+	    trusted_tooltips_hide_tip (widget);
+	  break;
+	default:
+	  break;
+	}
+    }
+  else
+    {
+      if (event->type != GDK_KEY_PRESS && event->type != GDK_KEY_RELEASE)
+	{
+	  event_widget = gtk_get_event_widget (event);
+	  if (event_widget != widget)
+	    return;
+	}
+
+      if (tooltips->pager != NULL) /* handler pager tooltips special case */
+	{
+	  static WnckWorkspace *current = NULL;
+	  if (event->type == GDK_MOTION_NOTIFY || event->type == GDK_ENTER_NOTIFY)
+	    {
+	      WnckWorkspace *tip_ws = g_object_get_data (G_OBJECT (tooltips->pager), 
+							 "tip_ws");
+
+	      if (current != tip_ws) 
+		{
+		  /* do something only if the workspace changed */
+		  current = tip_ws;
+		  trusted_tooltips_set_active_widget (tooltips, NULL);
+		  trusted_tooltips_start_delay (tooltips, widget);
+		}
+	    }
+	  if (event->type == GDK_LEAVE_NOTIFY)
+	    {
+	      trusted_tooltips_set_active_widget (tooltips, NULL);
+	      current = NULL;
+	    }
+	} 
+      else
+	{
+	  switch (event->type)
+	    {
+	    case GDK_EXPOSE:
+	      /* do nothing */
+	      break;
+	    case GDK_ENTER_NOTIFY:
+	      if (!(GTK_IS_MENU_ITEM (widget) && gtk_menu_item_get_submenu(GTK_MENU_ITEM (widget))))
+		trusted_tooltips_start_delay (tooltips, widget);
+	      break;
+	      
+	    case GDK_LEAVE_NOTIFY:
+	      {
+		gboolean use_sticky_delay;
+		
+		use_sticky_delay = tooltips->tip_window &&
+		  gtk_widget_get_visible (tooltips->tip_window);
+		trusted_tooltips_set_active_widget (tooltips, NULL);
+		tooltips->use_sticky_delay = use_sticky_delay;
+	      }
+	      break;
+
+	    case GDK_MOTION_NOTIFY:
+	      /* Handle menu items specially ... pend popup for each motion
+	       * on other widgets, we ignore motion.
+	       */
+	      if (GTK_IS_MENU_ITEM (widget) && !gtk_menu_item_get_submenu(GTK_MENU_ITEM (widget)))
+		{
+		  /* Completely evil hack to make sure we get the LEAVE_NOTIFY
+		   */
+		  /* GTK_PRIVATE_SET_FLAG (widget, GTK_LEAVE_PENDING); */
+		  trusted_tooltips_set_active_widget (tooltips, NULL);
+		  trusted_tooltips_start_delay (tooltips, widget);
+		  break;
+		}
+	      break;		/* ignore */
+	    case GDK_BUTTON_PRESS:
+	    case GDK_BUTTON_RELEASE:
+	    case GDK_KEY_PRESS:
+	    case GDK_KEY_RELEASE:
+	    case GDK_PROXIMITY_IN:
+	    case GDK_SCROLL:
+	      trusted_tooltips_set_active_widget (tooltips, NULL);
+	      break;
+	    default:
+	      break;
+	    }
+	}
+    }
+}
+
+static void
+trusted_tooltips_widget_unmap (GtkWidget *widget,
+			   gpointer   data)
+{
+  TrustedTooltipsData *tooltipsdata = (TrustedTooltipsData *)data;
+  TrustedTooltips *tooltips = tooltipsdata->tooltips;
+  
+  if (tooltips->active_tips_data &&
+      (tooltips->active_tips_data->widget == widget))
+    trusted_tooltips_set_active_widget (tooltips, NULL);
+}
+
+static void
+trusted_tooltips_widget_remove (GtkWidget *widget,
+			    gpointer   data)
+{
+  TrustedTooltipsData *tooltipsdata = (TrustedTooltipsData*) data;
+  TrustedTooltips *tooltips = tooltipsdata->tooltips;
+
+  trusted_tooltips_widget_unmap (widget, data);
+  tooltips->tips_data_list = g_list_remove (tooltips->tips_data_list,
+					    tooltipsdata);
+  trusted_tooltips_destroy_data (tooltipsdata);
+}
+
+void
+_trusted_tooltips_toggle_keyboard_mode (GtkWidget *widget)
+{
+  if (get_keyboard_mode (widget))
+    stop_keyboard_mode (widget);
+  else
+    start_keyboard_mode (widget);
+}
+
+/**
+ * trusted_tooltips_get_info_from_tip_window:
+ * @tip_window: a #GtkWindow 
+ * @tooltips: the return location for the tooltips which are displayed 
+ *    in @tip_window, or %NULL
+ * @current_widget: the return location for the widget whose tooltips 
+ *    are displayed, or %NULL
+ * 
+ * Determines the tooltips and the widget they belong to from the window in 
+ * which they are displayed. 
+ *
+ * This function is mostly intended for use by accessibility technologies;
+ * applications should have little use for it.
+ * 
+ * Return value: %TRUE if @tip_window is displaying tooltips, otherwise %FALSE.
+ *
+ * Since: 2.4
+ **/
+gboolean
+trusted_tooltips_get_info_from_tip_window (GtkWindow    *tip_window,
+                                       TrustedTooltips **tooltips,
+                                       GtkWidget   **current_widget)
+{
+  TrustedTooltips  *current_tooltips;  
+  gboolean has_tips;
+
+  g_return_val_if_fail (GTK_IS_WINDOW (tip_window), FALSE);
+
+  current_tooltips = g_object_get_data (G_OBJECT (tip_window), tooltips_info_key);
+
+  has_tips = current_tooltips != NULL;
+
+  if (tooltips)
+    *tooltips = current_tooltips;
+  if (current_widget)
+    *current_widget = has_tips ? current_tooltips->active_tips_data->widget : NULL;
+
+  return has_tips;
+}
+void
+trusted_tooltips_set_pager (TrustedTooltips *tooltips,
+			    WnckPager *pager)
+{
+   tooltips->pager = pager;
+}
+#endif /* HAVE_XTSOL */
+#define __TRUSTED_TOOLTIPS_C__
diff -urN libwnck.orig/libwnck/trusted-tooltips.h libwnck.new/libwnck/trusted-tooltips.h
--- libwnck.orig/libwnck/trusted-tooltips.h	1970-01-01 01:00:00.000000000 +0100
+++ libwnck.new/libwnck/trusted-tooltips.h	2008-08-06 23:43:40.108722000 +0100
@@ -0,0 +1,119 @@
+/* GTK - The GIMP Toolkit
+ * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+ */
+
+/*
+ * Modified by the GTK+ Team and others 1997-2000.  See the AUTHORS
+ * file for a list of people on the GTK+ Team.  See the ChangeLog
+ * files for a list of changes.  These files are distributed with
+ * GTK+ at ftp://ftp.gtk.org/pub/gtk/. 
+ */
+
+#ifndef __TRUSTED_TOOLTIPS_H__
+#define __TRUSTED_TOOLTIPS_H__
+
+#include <gtk/gtk.h>
+#include "pager.h"
+
+G_BEGIN_DECLS
+
+#define TRUSTED_TOOLTIPS_TYPE                  (trusted_tooltips_get_type ())
+#define TRUSTED_TOOLTIPS(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), TRUSTED_TOOLTIPS_TYPE, TrustedTooltips))
+#define TRUSTED_TOOLTIPS_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass), TRUSTED_TOOLTIPS_TYPE, TrustedTooltipsClass))
+#define IS_TRUSTED_TOOLTIPS(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TRUSTED_TOOLTIPS_TYPE))
+#define IS_TRUSTED_TOOLTIPS_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass), TRUSTED_TOOLTIPS_TYPE))
+#define TRUSTED_TOOLTIPS_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj), TRUSTED_TOOLTIPS_TYPE, TrustedTooltipsClass))
+
+
+typedef struct _TrustedTooltips	 TrustedTooltips;
+typedef struct _TrustedTooltipsClass TrustedTooltipsClass;
+typedef struct _TrustedTooltipsData	 TrustedTooltipsData;
+
+struct _TrustedTooltipsData
+{
+  TrustedTooltips *tooltips;
+  GtkWidget *widget;
+  gchar *tip_text;
+  gchar *trusted_label;
+  GdkColor  *trusted_color;
+  gchar *tip_private;
+};
+
+struct _TrustedTooltips
+{
+  GObject parent_instance;
+
+  GtkWidget *tip_window;
+  GtkWidget *tip_label;
+  GtkWidget *tip_trusted_label;
+  GtkWidget *event;
+  TrustedTooltipsData *active_tips_data;
+  GList *tips_data_list;
+
+  guint   delay : 30;
+  guint	  enabled : 1;
+  guint   have_grab : 1;
+  guint   use_sticky_delay : 1;
+  gint	  timer_tag;
+  GTimeVal last_popdown;
+  WnckPager *pager;
+};
+
+struct _TrustedTooltipsClass
+{
+  GObjectClass parent_class;
+
+  /* Padding for future expansion */
+  void (*_gtk_reserved1) (void);
+  void (*_gtk_reserved2) (void);
+  void (*_gtk_reserved3) (void);
+  void (*_gtk_reserved4) (void);
+};
+
+GType		 trusted_tooltips_get_type	   (void) G_GNUC_CONST;
+TrustedTooltips*	 trusted_tooltips_new	   (void);
+
+void		 trusted_tooltips_enable	   (TrustedTooltips   *tooltips);
+void		 trusted_tooltips_disable	   (TrustedTooltips   *tooltips);
+#ifndef GTK_DISABLE_DEPRECATED
+void		 trusted_tooltips_set_delay	   (TrustedTooltips   *tooltips,
+					    guint	   delay);
+#endif /* GTK_DISABLE_DEPRECATED */
+void		 trusted_tooltips_set_tip	   (TrustedTooltips   *tooltips,
+						    GtkWidget	  *widget,
+						    const gchar   *tip_text,
+						    const gchar   *trusted_label,
+						    GdkColor	  *trusted_color,
+						    const gchar   *tip_private);
+TrustedTooltipsData* trusted_tooltips_data_get	   (GtkWidget	  *widget);
+void             trusted_tooltips_force_window (TrustedTooltips   *tooltips);
+
+
+void             _trusted_tooltips_toggle_keyboard_mode (GtkWidget *widget);
+
+gboolean         trusted_tooltips_get_info_from_tip_window (GtkWindow    *tip_window,
+                                                        TrustedTooltips **tooltips,
+                                                        GtkWidget   **current_widget);
+
+void		 trusted_tooltips_set_pager	  (TrustedTooltips *tooltips,
+						   WnckPager *pager);
+
+
+G_END_DECLS
+
+#endif /* __TRUSTED_TOOLTIPS_H__ */
